# Get contract package NFT actions for a token

Get token NFT actions by contract package hash and token ID

```
GET /contract-packages/{contract_package_hash}/nft-tokens/{token_id}/nft-token-actions
```

## Query params

None

## Sorting

| Property    | Description                   |
| ----------- | ----------------------------- |
| `timestamp` | Sort NFT actions by timestamp |

## Optional properties

| Property                        | Type                                                                                        | Description                                                       |
| ------------------------------- | ------------------------------------------------------------------------------------------- | ----------------------------------------------------------------- |
| `contract_package`              | [`ContractPackage`](https://docs.cspr.cloud/1.5.x/rest-api/contract-package)                | NFT contract package                                              |
| `deploy`                        | [`Deploy`](https://docs.cspr.cloud/1.5.x/rest-api/deploy)                                   | Deploy in which the token action occurred                         |
| `from_public_key`               | `string(68)`                                                                                | Action source public key if it's an account                       |
| `to_public_key`                 | `string(68)`                                                                                | Action target public key if it's an account                       |
| `to_account_info`               | [`AccountInfo`](https://docs.cspr.cloud/1.5.x/rest-api/account-info)                        | Action source account info if it's an account                     |
| `to_centralized_account_info`   | [`CentralizedAccountInfo`](https://docs.cspr.cloud/1.5.x/rest-api/centralized-account-info) | Action target centralized account info if it's an account         |
| `from_account_info`             | [`AccountInfo`](https://docs.cspr.cloud/1.5.x/rest-api/account-info)                        | Action target account info if it's an account                     |
| `from_centralized_account_info` | [`CentralizedAccountInfo`](https://docs.cspr.cloud/1.5.x/rest-api/centralized-account-info) | Action target centralized account info if it's an account         |
| `from_cspr_name`                | `string`                                                                                    | Primary CSPR.name of the source account, if it is an account      |
| `to_cspr_name`                  | `string`                                                                                    | Primary CSPR.name of the destination account, if it is an account |

## Response

[`PaginatedResponse`](https://docs.cspr.cloud/1.5.x/documentation/overview/pagination)[`<NFTTokenAction>`](https://docs.cspr.cloud/1.5.x/rest-api/non-fungible-token)

## Example

```bash
curl -X 'GET' \
  'https://api.testnet.cspr.cloud/contract-packages/006c68af5f767e406cccd326f8d8bba81dec20d2578f308d33e3bbf08ee5d383/nft-tokens/0/nft-token-actions' \
  -H 'accept: application/json' \
  -H 'authorization: 55f79117-fc4d-4d60-9956-65423f39a06a'
```

```json
{
  "data": [
    {
      "contract_package_hash": "006c68af5f767e406cccd326f8d8bba81dec20d2578f308d33e3bbf08ee5d383",
      "deploy_hash": "50b96b517040247a080a2a59150a53bd60cbc4733ebb7ccfe800686496ea6ac6",
      "from_hash": "d0bc9ca1353597c4004b8f881b397a89c1779004f5e547e04b57c2e7967c6269",
      "from_type": 0,
      "nft_action_id": 3,
      "timestamp": "2022-10-18T15:51:01Z",
      "to_hash": "a2f88f07fa73ed826deaf761d37ece021e1990603afc68ba2fda09332dce1534",
      "to_type": 1,
      "token_id": "0",
      "token_tracking_id": 20458
    },
    {
      "contract_package_hash": "006c68af5f767e406cccd326f8d8bba81dec20d2578f308d33e3bbf08ee5d383",
      "deploy_hash": "512006c596e47ec764c5a05969b263728e2dbd479e1ad0b9e8b9913ec4483c38",
      "block_height": 150042,
      "from_hash": null,
      "from_type": null,
      "nft_action_id": 1,
      "timestamp": "2023-01-01T09:33:05Z",
      "to_hash": "d0bc9ca1353597c4004b8f881b397a89c1779004f5e547e04b57c2e7967c6269",
      "to_type": 0,
      "token_id": "0",
      "token_tracking_id": 20458
    }
  ],
  "item_count": 2,
  "page_count": 1
}
```
